from brpatientApp.models import Patient,PatientInfo
from brvisitApp.models import PatientVisit
from brsessionApp.models import PatientSessionItem
'''
MARKETING_CODE_CHOICES = (
    ('NEW_PT', "مريض جديد"), # New Patient
    ('V_NO_S', " كشف بدون جلسات"),# Visit no session
    ('V_W_S', "كشف منتظر جلسات"),# Visit wait session هيبدأ بعدين لكن اتشخص انه المفروض يعمل جلسات 
    ('V_S_S', "كشف بدأ جلسات"),# Visit start session 
    ('NT_ELG', "غير مؤهل للعلاج"),# Not eligible for treatment
    ('OTHER', "أخرى"),# أى حاجه تانية هنكتب فى ملاحظات الدكتور - او ملاحظات الاستقبال    
)
'''
all_patients = Patient.objects.all()
for patient in all_patients:
    #print(patient.code)
    pt_visits =  PatientVisit.objects.filter(patient=patient,visit_status="4F")
    pt_sessions = PatientSessionItem.objects.filter(session__patient=patient,entry_status__in=["4F","1I"]).order_by("-entry_datetime")
    pt_info_objs = PatientInfo.objects.filter(patient=patient,)
    if not pt_info_objs:
        patient_info = PatientInfo.objects.create(patient=patient,last_update_by_id=1)
        if not pt_visits and not pt_sessions : 
            patient_info.marketing_code="NEW_PT"
            patient_info.save()
        elif pt_visits and not pt_sessions : 
            patient_info.marketing_code="V_NO_S"
            patient_info.last_visit=pt_visits.first().visit_day
            patient_info.save()
        elif pt_visits and pt_sessions : 
            patient_info.marketing_code="V_S_S"
            patient_info.last_visit=pt_visits.first().visit_day
            patient_info.last_session=pt_sessions.first().entry_datetime
            patient_info.save()
        elif not pt_visits and pt_sessions :
            patient_info.marketing_code="V_S_S"
            patient_info.last_session=pt_sessions.first().entry_datetime
            patient_info.save()
        else : 
            patient_info.marketing_code="OTHER"
            patient_info.save()
    else : 
        patient_info = pt_info_objs
        if not pt_visits and not pt_sessions : patient_info.update(marketing_code="NEW_PT")
        elif pt_visits and not pt_sessions : patient_info.update(marketing_code="V_NO_S",last_visit=pt_visits.first().visit_day)
        elif pt_visits and pt_sessions : patient_info.update(marketing_code="V_S_S",last_visit=pt_visits.first().visit_day,last_session=pt_sessions.first().entry_datetime)
        elif not pt_visits and pt_sessions :patient_info.update(marketing_code="V_S_S",last_session=pt_sessions.first().entry_datetime)
        else : patient_info.update(marketing_code="OTHER")